/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package ex2;

import org.junit.Test;
import static org.junit.Assert.*;
import org.junit.Before;

/**
 *
 * @author rosmord
 */
public class CalculetteModeleTest {

    private CalculetteModele calc;

    @Before
    public void preparer() {
        calc = new CalculetteModele();
    }

    private void taper(String nombre) {
        for (int i = 0; i < nombre.length(); i++) {
            calc.ajouterSymbole(nombre.charAt(i));
        }
    }

    /**
     * Test of getValeurCalculee method, of class CalculetteModele.
     */
    @Test
    public void testGetValeur() {
        System.out.println("getValeur");
        taper("12.3");
        assertEquals("12.3", calc.getAffichage());
        calc.additionnerOp();
        taper("4");
        calc.egalOp();
        assertEquals(12.3 + 4, calc.getValeurCalculee(), 0.001);
    }

    /**
     * Test of ajouterSymbole method, of class CalculetteModele.
     */
    @Test
    public void testAjouterSymbole() {
        calc.ajouterSymbole('1');
        calc.ajouterSymbole('2');
        calc.ajouterSymbole('.');
        calc.ajouterSymbole('2');
        assertEquals("12.2", calc.getAffichage());
    }

    /**
     * Test of ajouterSymbole method, of class CalculetteModele.
     */
    @Test
    public void testAjouterDeuxPoints() {
        calc.ajouterSymbole('1');
        calc.ajouterSymbole('2');
        calc.ajouterSymbole('.');
        calc.ajouterSymbole('2');
        calc.ajouterSymbole('.');
        assertEquals("12.2", calc.getAffichage());
    }

    /**
     * Test of getNombreEnConstruction method, of class CalculetteModele.
     */
    @Test
    public void testGetNombreEnConstruction() {
        calc.ajouterSymbole('1');
        calc.ajouterSymbole('2');
        calc.ajouterSymbole('.');
        calc.ajouterSymbole('2');
        assertEquals(12.2, calc.getNombreEnConstruction(), 0.0001);
    }

    /**
     * Test of multiplierOp method, of class CalculetteModele.
     */
    @Test
    public void testMultiplier() {
        taper("11");
        calc.multiplierOp();
        taper("12");
        calc.egalOp();
        assertEquals(132.0, calc.getValeurAffichage(), 0.0001);
    }

    /**
     * Test of additionnerOp method, of class CalculetteModele.
     */
    @Test
    public void testSuiteDoperation() {
        taper("12");
        calc.additionnerOp();
        taper("2");
        calc.additionnerOp();
        assertEquals(14.0, calc.getValeurCalculee(), 0.001);
        taper("3");
        calc.egalOp();
        assertEquals(17.0, calc.getValeurCalculee(), 0.001);
    }

    @Test
    public void testOperateursSansPriorite() {
        taper("12");
        calc.additionnerOp();
        taper("2");
        calc.multiplierOp();
        taper("3");
        calc.egalOp();
        // on simule une calculette "bête":
        // Doit donner (12+2)*3 et non 12+(2*3)
        assertEquals((12+2) * 3.0, calc.getValeurAffichage(), 0.0001);
    }

    @Test
    public void testEgalIntermediaire() {
        taper("10");
        calc.additionnerOp();
        taper("2");
        calc.egalOp();
        calc.multiplierOp();
        taper("2");
        calc.egalOp();
        assertEquals(24.0, calc.getValeurAffichage(), 0.001);
    }

    /**
     * Test of soustraireOp method, of class CalculetteModele.
     */
    @Test
    public void testRetirer() {
        taper("11");
        calc.soustraireOp();
        taper("20");
        calc.egalOp();
        assertEquals(-9.0, calc.getValeurAffichage(), 0.001);
    }

    /**
     * Test of diviserOp method, of class CalculetteModele.
     */
    @Test
    public void testDiviser() {
        taper("1");
        calc.diviserOp();
        taper("3");
        calc.egalOp();
        assertEquals(0.3333333333333333, calc.getValeurAffichage(), 0.001);
    }
}